import { useCssVars as xe, ref as d, computed as k, watch as re, onMounted as Ce, openBlock as i, createElementBlock as v, normalizeClass as U, createElementVNode as f, normalizeStyle as s, toDisplayString as b, createCommentVNode as p, withDirectives as Se, createBlock as H, Fragment as q, renderList as X, unref as c, createSlots as we, withCtx as P, renderSlot as w, normalizeProps as Ae, guardReactiveProps as Ie, createVNode as $e, nextTick as Oe } from "vue";
import { u as ze, c as Pe, t as Ne, a as De, p as N, b as Fe, o as We, e as ue, g as Ve, $ as Te, d as Me, i as D, f as F, q as Ee, r as Ge } from "./index-igxqCP2w.js";
import { u as se } from "./useNestedProp-CSVnZVwZ.js";
import Be from "./vue-ui-sparkline-DX79otAB.js";
import ie from "./BaseIcon-CaYP30Aq.js";
import { u as Le, U as Re, v as Ue } from "./usePrinter-CnZYDQXB.js";
import { _ as He } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const qe = ["id"], Xe = { style: { "z-index": "1", "padding-right": "24px" } }, je = ["onClick"], Je = ["data-cell"], Ke = ["data-cell", "onPointerenter"], Qe = ["data-cell"], Ye = ["data-cell"], Ze = ["data-cell"], et = ["data-cell"], tt = {
  key: 0,
  ref: "source",
  dir: "auto"
}, at = {
  __name: "vue-ui-table-sparkline",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(de, { expose: ve }) {
    const y = de;
    xe((t) => ({
      dba64318: t.tdo
    }));
    const { vue_ui_table_sparkline: ce } = ze(), W = d(Pe()), j = d(0), V = d(0), T = d(null), e = k({
      get: () => J(),
      set: (t) => t
    });
    function J() {
      const t = se({
        userConfig: y.config,
        defaultConfig: ce
      });
      return t.theme ? {
        ...se({
          userConfig: Ne.vue_ui_table_sparkline[t.theme] || y.config,
          defaultConfig: t
        }),
        customPalette: De[t.theme] || N
      } : t;
    }
    re(() => y.config, (t) => {
      e.value = J(), ee(), V.value += 1;
    }, { deep: !0 }), re(() => y.dataset, (t) => {
      m.value = C.value, V.value += 1;
    }, { deep: !0 });
    const { isPrinting: K, isImaging: Q, generatePdf: Y, generateImage: Z } = Le({
      elementId: `table_${W.value}`,
      fileName: e.value.title.text || "vue-ui-table-sparkline"
    }), fe = k(() => Fe(e.value.customPalette)), A = d(null), M = d(!1), pe = k(() => e.value.responsiveBreakpoint);
    Ce(() => {
      ee();
    });
    const E = d(e.value.colNames);
    function ee() {
      We(y.dataset) && ue({
        componentName: "VueUiTableSparkline",
        type: "dataset"
      });
      const t = new ResizeObserver((l) => {
        l.forEach((a) => {
          M.value = a.contentRect.width < pe.value;
        });
      });
      A.value && t.observe(A.value), E.value = [];
      for (let l = 0; l < le.value; l += 1)
        E.value.push(e.value.colNames[l] || `col ${l}`);
    }
    const te = k(() => (y.dataset.forEach((t, l) => {
      Ve({
        datasetObject: t,
        requiredAttributes: ["name", "values"]
      }).forEach((a) => {
        ue({
          componentName: "VueUiTableSparkline",
          type: "datasetSerieAttribute",
          property: a,
          index: l
        });
      });
    }), y.dataset.map((t, l) => {
      const a = (t.values || []).map((n) => isNaN(n) ? 0 : n ?? 0), r = a.reduce((n, h) => n + h, 0), u = r / a.length, o = Te(a);
      return {
        ...t,
        values: t.values || [],
        color: Me(t.color) || fe.value[l] || N[l] || N[l % N.length],
        sum: r,
        average: u,
        median: o,
        sparklineDataset: a.map((n, h) => ({
          period: e.value.colNames[h] || `col ${h}`,
          value: n || 0
        }))
      };
    })));
    function me(t) {
      const a = (t[0].values || []).map(
        (u, o) => t.map((n) => n.values[o] || [])
      ).map(
        (u) => u.map((o, n) => [o, n]).sort((o, n) => n[0] - o[0]).map((o) => o[1])
      );
      return t.map((u, o) => ({
        ...u,
        values: u.values || [],
        orders: a[o]
      }));
    }
    const C = k(() => me(te.value)), m = d(C.value), ge = k(() => Math.max(...m.value.map((t) => (t.values || []).length))), I = d(void 0), G = d(!1), S = d(void 0), $ = d(-1);
    function O() {
      G.value = !1, S.value = void 0, g.value = void 0, $.value = -1, m.value = C.value;
    }
    function ae(t, l) {
      if (["name", "sum", "average", "median"].includes(t.type)) {
        be(t.type);
        return;
      }
      if (!L(l)) return;
      if (x.value = l, g.value = void 0, $.value === 1) {
        $.value = -1, S.value = void 0, O();
        return;
      }
      G.value = !0, S.value = l;
      const a = C.value.map((n) => n.values[l] || []), r = I.value === l ? 1 : -1;
      $.value = r, l === I.value ? I.value = void 0 : I.value = l;
      const o = a.map((n, h) => [h, n]).sort((n, h) => r * (h[1] - n[1])).map((n) => n[0]).map((n) => C.value[n]);
      m.value = o, V.value += 1;
    }
    const le = k(() => Math.max(...y.dataset.map((t) => (t.values || []).length))), _ = k(() => {
      let t = E.value.map((a) => ({
        type: "reg",
        value: a
      }));
      if (!t.length)
        for (let a = 0; a < le.value; a += 1)
          t.push({ type: "reg", value: `col ${a + 1}` });
      e.value.showTotal && (t = [...t, { type: "sum", value: e.value.translations.total }]);
      let l;
      return e.value.showAverage && e.value.showMedian ? l = [
        ...t,
        { type: "average", value: e.value.translations.average },
        { type: "median", value: e.value.translations.median }
      ] : e.value.showAverage && !e.value.showMedian ? l = [...t, { type: "average", value: e.value.translations.average }] : !e.value.showAverage && e.value.showMedian ? l = [...t, { type: "median", value: e.value.translations.median }] : l = t, e.value.showSparklines ? [...l, { type: "chart", value: e.value.translations.chart }] : l;
    }), z = d({
      name: -1,
      sum: -1,
      average: -1,
      median: -1
    }), g = d(void 0);
    function be(t) {
      if (!m.value || m.value.length === 0 || !R(t)) return;
      if (g.value !== t && (g.value = void 0), S.value = void 0, z.value[t] === -1 && g.value) {
        g.value = void 0, O();
        return;
      }
      g.value = t, G.value = !0, z.value[t] = z.value[t] === -1 ? 1 : -1;
      const l = z.value[t], a = [...m.value].sort((r, u) => {
        const o = r[t] ?? (typeof r[t] == "number" ? 0 : ""), n = u[t] ?? (typeof u[t] == "number" ? 0 : "");
        return typeof o == "string" && typeof n == "string" ? l === -1 ? o.localeCompare(n) : n.localeCompare(o) : typeof o == "number" && typeof n == "number" ? l === -1 ? o - n : n - o : 0;
      });
      m.value = a;
    }
    const x = d(void 0), B = d(void 0);
    function ye({ dataIndex: t, serieIndex: l }) {
      x.value = t, B.value = l, T.value[t] && !M.value && T.value[t].scrollIntoView({ behavior: "smooth", block: "nearest", inline: "center" });
    }
    const oe = d(!1);
    function he(t) {
      oe.value = t, j.value += 1;
    }
    function ne() {
      Oe(() => {
        const t = [e.value.translations.serie].concat(_.value), l = te.value.map((u, o) => [
          [u.name],
          u.values,
          [u.sum],
          [u.average],
          [u.median]
        ]), a = [t].concat(l), r = Ee(a);
        Ge({
          csvContent: r,
          title: e.value.title.text || "vue-ui-table-sparkline"
        });
      });
    }
    function L(t) {
      return e.value.sortedDataColumnIndices.includes(t);
    }
    function R(t) {
      return t.type === "name" || t === "name" ? e.value.sortedSeriesName : t.type === "sum" || t === "sum" ? e.value.sortedSum : t.type === "average" || t === "average" ? e.value.sortedAverage : t.type === "median" || t === "median" ? e.value.sortedMedian : !1;
    }
    function ke(t, l) {
      return ["sum", "average", "median"].includes(l.type) ? g.value === l.type ? 1 : 0.3 : t === S.value ? 1 : 0.3;
    }
    function _e() {
      e.value.resetSortOnClickOutside && O();
    }
    return ve({
      generatePdf: Y,
      generateImage: Z,
      generateCsv: ne,
      restoreOrder: O
    }), (t, l) => (i(), v("div", {
      ref_key: "tableContainer",
      ref: A,
      class: U({ "vue-ui-responsive": M.value }),
      style: { overflow: "hidden" },
      id: `table_${W.value}`
    }, [
      f("div", {
        style: { overflow: "auto" },
        onPointerleave: l[1] || (l[1] = (a) => {
          B.value = void 0, x.value = void 0;
        })
      }, [
        f("table", {
          class: "vue-ui-data-table",
          style: s({ fontFamily: e.value.fontFamily, position: "relative" })
        }, [
          e.value.title.text ? (i(), v("caption", {
            key: 0,
            style: s({ backgroundColor: e.value.title.backgroundColor })
          }, [
            f("div", {
              style: s({
                fontSize: `${e.value.title.fontSize}px`,
                fontWeight: e.value.title.bold ? "bold" : "normal",
                color: e.value.title.color,
                textAlign: e.value.title.textAlign
              })
            }, b(e.value.title.text), 5),
            e.value.title.subtitle.text ? (i(), v("div", {
              key: 0,
              style: s({
                fontSize: `${e.value.title.subtitle.fontSize}px`,
                fontWeight: e.value.title.subtitle.bold ? "bold" : "normal",
                color: e.value.title.subtitle.color,
                textAlign: e.value.title.textAlign
              })
            }, b(e.value.title.subtitle.text), 5)) : p("", !0)
          ], 4)) : p("", !0),
          f("thead", Xe, [
            Se((i(), v("tr", {
              role: "row",
              class: "vue-ui-data-table__thead-row",
              style: s({
                backgroundColor: e.value.thead.backgroundColor,
                color: e.value.thead.color
              })
            }, [
              f("th", {
                role: "cell",
                style: s({
                  backgroundColor: e.value.thead.backgroundColor,
                  border: e.value.thead.outline,
                  textAlign: e.value.thead.textAlign,
                  fontWeight: e.value.thead.bold ? "bold" : "normal",
                  cursor: e.value.sortedSeriesName ? "pointer" : "default"
                }),
                class: "sticky-col-first",
                onClick: l[0] || (l[0] = (a) => ae({ type: "name" }, null))
              }, [
                f("div", {
                  style: s({
                    display: "flex",
                    flexDirection: "row",
                    alignItems: "center",
                    gap: "6px",
                    justifyContent: e.value.thead.textAlign
                  })
                }, [
                  f("span", null, b(e.value.translations.serie), 1),
                  e.value.sortedSeriesName ? (i(), H(ie, {
                    key: 0,
                    size: 18,
                    name: "sort",
                    stroke: e.value.thead.color,
                    style: s({
                      opacity: g.value === "name" ? 1 : 0.3
                    })
                  }, null, 8, ["stroke", "style"])) : p("", !0)
                ], 4)
              ], 4),
              (i(!0), v(q, null, X(_.value, (a, r) => (i(), v("th", {
                role: "cell",
                style: s({
                  background: e.value.thead.backgroundColor,
                  border: e.value.thead.outline,
                  textAlign: e.value.thead.textAlign,
                  fontWeight: e.value.thead.bold ? "bold" : "normal",
                  minWidth: r === _.value.length - 1 ? `${e.value.sparkline.dimensions.width}px` : "48px",
                  cursor: L(r) || R(a) ? "pointer" : "default",
                  paddingRight: r === _.value.length - 1 && e.value.userOptions.show ? "36px" : ""
                }),
                onClick: () => ae(a, r),
                class: U({ "sticky-col": r === _.value.length - 1 && e.value.showSparklines })
              }, [
                f("div", {
                  style: s({
                    display: "flex",
                    flexDirection: "row",
                    alignItems: "center",
                    gap: "6px",
                    justifyContent: e.value.thead.textAlign
                  })
                }, [
                  f("span", null, b(a.value), 1),
                  L(r) || R(a) ? (i(), H(ie, {
                    key: 0,
                    size: 18,
                    name: "sort",
                    stroke: e.value.thead.color,
                    style: s({
                      opacity: ke(r, a)
                    })
                  }, null, 8, ["stroke", "style"])) : p("", !0)
                ], 4),
                e.value.userOptions.show && r === _.value.length - 1 ? (i(), H(Re, {
                  ref_for: !0,
                  ref: "details",
                  key: `user_option_${j.value}`,
                  backgroundColor: e.value.thead.backgroundColor,
                  color: e.value.thead.color,
                  isPrinting: c(K),
                  isImaging: c(Q),
                  uid: W.value,
                  hasPdf: e.value.userOptions.buttons.pdf,
                  hasXls: e.value.userOptions.buttons.csv,
                  hasImg: e.value.userOptions.buttons.img,
                  hasFullscreen: e.value.userOptions.buttons.fullscreen,
                  isFullscreen: oe.value,
                  titles: { ...e.value.userOptions.buttonTitles },
                  chartElement: A.value,
                  position: e.value.userOptions.position,
                  onToggleFullscreen: he,
                  onGeneratePdf: c(Y),
                  onGenerateImage: c(Z),
                  onGenerateCsv: ne
                }, we({ _: 2 }, [
                  t.$slots.optionPdf ? {
                    name: "optionPdf",
                    fn: P(() => [
                      w(t.$slots, "optionPdf", {}, void 0, !0)
                    ]),
                    key: "0"
                  } : void 0,
                  t.$slots.optionCsv ? {
                    name: "optionCsv",
                    fn: P(() => [
                      w(t.$slots, "optionCsv", {}, void 0, !0)
                    ]),
                    key: "1"
                  } : void 0,
                  t.$slots.optionImg ? {
                    name: "optionImg",
                    fn: P(() => [
                      w(t.$slots, "optionImg", {}, void 0, !0)
                    ]),
                    key: "2"
                  } : void 0,
                  t.$slots.optionFullscreen ? {
                    name: "optionFullscreen",
                    fn: P(({ toggleFullscreen: u, isFullscreen: o }) => [
                      w(t.$slots, "optionFullscreen", Ae(Ie({ toggleFullscreen: u, isFullscreen: o })), void 0, !0)
                    ]),
                    key: "3"
                  } : void 0
                ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "onGeneratePdf", "onGenerateImage"])) : p("", !0)
              ], 14, je))), 256))
            ], 4)), [
              [c(Ue), _e]
            ])
          ]),
          f("tbody", null, [
            (i(!0), v(q, null, X(m.value, (a, r) => (i(), v("tr", {
              role: "row",
              style: s({
                backgroundColor: e.value.tbody.backgroundColor,
                color: e.value.tbody.color
              }),
              class: U({ "vue-ui-data-table__tbody__row": !0, "vue-ui-data-table__tbody__row-even": r % 2 === 0, "vue-ui-data-table__tbody__row-odd": r % 2 !== 0 })
            }, [
              f("td", {
                role: "cell",
                style: s({
                  backgroundColor: e.value.tbody.backgroundColor,
                  border: e.value.tbody.outline,
                  fontSize: `${e.value.tbody.fontSize}px`,
                  fontWeight: e.value.tbody.bold ? "bold" : "normal",
                  textAlign: e.value.tbody.textAlign
                }),
                "data-cell": e.value.translations.serie,
                class: "vue-ui-data-table__tbody__td sticky-col-first"
              }, [
                f("div", {
                  dir: "auto",
                  style: s({
                    display: "flex",
                    flexDirection: "row",
                    alignItems: "center",
                    gap: "6px",
                    justifyContent: e.value.tbody.textAlign
                  })
                }, [
                  e.value.tbody.showColorMarker ? (i(), v("span", {
                    key: 0,
                    style: s({ color: a.color })
                  }, "⬤", 4)) : p("", !0),
                  f("span", null, b(a.name ?? "-"), 1)
                ], 4)
              ], 12, Je),
              (i(!0), v(q, null, X(ge.value, (u, o) => (i(), v("td", {
                dir: "auto",
                role: "cell",
                ref_for: !0,
                ref_key: "TD",
                ref: T,
                style: s({
                  border: e.value.tbody.outline,
                  fontSize: `${e.value.tbody.fontSize}px`,
                  fontWeight: e.value.tbody.bold ? "bold" : "normal",
                  textAlign: e.value.tbody.textAlign,
                  background: x.value !== void 0 && o === x.value ? e.value.tbody.selectedColor.useSerieColor ? `${a.color.length > 7 ? a.color.slice(0, -2) : a.color}33` : e.value.tbody.selectedColor.fallback : ""
                }),
                "data-cell": _.value[o],
                class: "vue-ui-data-table__tbody__td",
                onPointerenter: (n) => {
                  B.value = r, x.value = o;
                }
              }, b([null, void 0].includes(a.values[o]) ? "-" : c(D)(
                e.value.formatter,
                Number(a.values[o]),
                c(F)({
                  p: e.value.prefix,
                  v: Number(a.values[o]),
                  s: e.value.suffix,
                  r: e.value.roundingValues
                }),
                { datapoint: a, seriesIndex: r, datapointIndex: o }
              )), 45, Ke))), 256)),
              e.value.showTotal ? (i(), v("td", {
                key: 0,
                dir: "auto",
                role: "cell",
                style: s({
                  border: e.value.tbody.outline,
                  fontSize: `${e.value.tbody.fontSize}px`,
                  fontWeight: e.value.tbody.bold ? "bold" : "normal",
                  textAlign: e.value.tbody.textAlign
                }),
                "data-cell": e.value.translations.total,
                class: "vue-ui-data-table__tbody__td"
              }, b(c(D)(
                e.value.formatter,
                a.sum,
                c(F)({
                  p: e.value.prefix,
                  v: a.sum,
                  s: e.value.suffix,
                  r: e.value.roundingTotal
                }),
                { datapoint: a.sum, seriesIndex: r }
              )), 13, Qe)) : p("", !0),
              e.value.showAverage ? (i(), v("td", {
                key: 1,
                dir: "auto",
                role: "cell",
                style: s({
                  border: e.value.tbody.outline,
                  fontSize: `${e.value.tbody.fontSize}px`,
                  fontWeight: e.value.tbody.bold ? "bold" : "normal",
                  textAlign: e.value.tbody.textAlign
                }),
                "data-cell": e.value.translations.average,
                class: "vue-ui-data-table__tbody__td"
              }, b(c(D)(
                e.value.formatter,
                a.average,
                c(F)({
                  p: e.value.prefix,
                  v: a.average,
                  s: e.value.suffix,
                  r: e.value.roundingAverage
                }),
                { datapoint: a.average, seriesIndex: r }
              )), 13, Ye)) : p("", !0),
              e.value.showMedian ? (i(), v("td", {
                key: 2,
                dir: "auto",
                role: "cell",
                style: s({
                  border: e.value.tbody.outline,
                  fontSize: `${e.value.tbody.fontSize}px`,
                  fontWeight: e.value.tbody.bold ? "bold" : "normal",
                  textAlign: e.value.tbody.textAlign
                }),
                "data-cell": e.value.translations.median,
                class: "vue-ui-data-table__tbody__td"
              }, b(c(D)(
                e.value.formatter,
                a.median,
                c(F)({
                  p: e.value.prefix,
                  v: a.median,
                  s: e.value.suffix,
                  r: e.value.roundingMedian
                }),
                { datapoint: a.median, seriesIndex: r }
              )), 13, Ze)) : p("", !0),
              e.value.showSparklines ? (i(), v("td", {
                key: 3,
                role: "cell",
                "data-cell": e.value.translations.chart,
                style: s({
                  border: e.value.tbody.outline,
                  fontSize: `${e.value.tbody.fontSize}px`,
                  fontWeight: e.value.tbody.bold ? "bold" : "normal",
                  textAlign: e.value.tbody.textAlign,
                  backgroundColor: e.value.tbody.backgroundColor,
                  padding: "0"
                }),
                class: "vue-ui-data-table__tbody__td sticky-col"
              }, [
                $e(Be, {
                  onHoverIndex: ({ index: u }) => ye({ dataIndex: u, serieIndex: r }),
                  "height-ratio": e.value.sparkline.dimensions.heightRatio,
                  "forced-padding": 30,
                  dataset: a.sparklineDataset,
                  showInfo: !1,
                  selectedIndex: x.value,
                  config: {
                    type: e.value.sparkline.type,
                    style: {
                      backgroundColor: "transparent",
                      animation: {
                        show: e.value.sparkline.animation.show && !c(K) && !c(Q),
                        animationFrames: e.value.sparkline.animation.animationFrames
                      },
                      line: {
                        color: a.color,
                        smooth: e.value.sparkline.smooth,
                        strokeWidth: e.value.sparkline.strokeWidth
                      },
                      bar: {
                        color: a.color
                      },
                      area: {
                        color: a.color,
                        opacity: e.value.sparkline.showArea ? 16 : 0,
                        useGradient: e.value.sparkline.useGradient
                      },
                      verticalIndicator: {
                        color: a.color
                      },
                      plot: {
                        radius: 9,
                        stroke: e.value.tbody.backgroundColor,
                        strokeWidth: 3
                      }
                    }
                  }
                }, null, 8, ["onHoverIndex", "height-ratio", "dataset", "selectedIndex", "config"])
              ], 12, et)) : p("", !0)
            ], 6))), 256))
          ])
        ], 4)
      ], 32),
      t.$slots.source ? (i(), v("div", tt, [
        w(t.$slots, "source", {}, void 0, !0)
      ], 512)) : p("", !0)
    ], 10, qe));
  }
}, dt = /* @__PURE__ */ He(at, [["__scopeId", "data-v-12c6b6f3"]]);
export {
  dt as default
};
